<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>SelectContainerHandler xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/ui/handlers/SelectContainerHandler.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/********</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> *    CEA LIST - initial API and implementation</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.ui.handlers;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionEvent;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.commands.ExecutionException;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.common.core.command.CommandResult;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.IDialogConstants;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.transformation.ui.dialogs.ContainerDialog;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.CommandSupport;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.RunnableWithResult;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.diagram.common.handlers.CmdHandler;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Display;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.InstanceSpecification;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <em class="jxr_javadoccomment"> * Call the dialogs for selecting a container rule</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/handlers/SelectContainerHandler.html">SelectContainerHandler</a> <strong class="jxr_keyword">extends</strong> CmdHandler {
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">	 * {@inheritDoc}</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  	@Override
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isEnabled() {
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  		updateSelectedEObject();
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  		<strong class="jxr_keyword">if</strong> ((selectedEObject instanceof Class) ||
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  				(selectedEObject instanceof InstanceSpecification)) {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  		}
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  		<strong class="jxr_keyword">if</strong> (selectedEObject instanceof Property) {
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  			Type type = ((Property) selectedEObject).getType();
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  			<strong class="jxr_keyword">if</strong> (type instanceof Class) {
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  			}
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  		}
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  	}
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_comment">	 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_comment">	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	@Override
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">public</strong> Object execute(ExecutionEvent event) <strong class="jxr_keyword">throws</strong> ExecutionException {
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		<strong class="jxr_keyword">if</strong> (!(selectedEObject instanceof NamedElement)) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  			<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		}
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  		NamedElement ne = (NamedElement) selectedEObject;
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		<strong class="jxr_keyword">final</strong> Shell shell = Display.getDefault().getActiveShell();
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		<strong class="jxr_keyword">if</strong> (ne instanceof Property) {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			<em class="jxr_comment">// treat property as the associated type</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  			Type type = ((Property) ne).getType();
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			<strong class="jxr_keyword">if</strong> (type instanceof Class) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  				ne = type;
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			}
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">final</strong> NamedElement element = ne;
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  		<em class="jxr_comment">// 1. select possible connectors according to port types</em>
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  		<em class="jxr_comment">// (only show compatible connectors check-box?)</em>
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  		<em class="jxr_comment">// 2. select implementation group according to connector type</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  		<strong class="jxr_keyword">if</strong> (element instanceof Class) {
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			<em class="jxr_comment">// container dialog: either extension, rule or interceptor</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			<em class="jxr_comment">// howto select? which? (and howto add/remove?) - Std - dialog is good?</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			CommandSupport.exec(<span class="jxr_string">"Select container"</span>, event, <strong class="jxr_keyword">new</strong> RunnableWithResult() {
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  				@Override
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  				<strong class="jxr_keyword">public</strong> CommandResult run() {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  					ContainerDialog elementSelector =
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  							<strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ContainerDialog.html">ContainerDialog</a>(shell, (Class) element);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  					elementSelector.setTitle(<span class="jxr_string">"Select container rules for component "</span> + element.getName());
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  					elementSelector.open();
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  					<strong class="jxr_keyword">if</strong> (elementSelector.getReturnCode() == IDialogConstants.OK_ID) {
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  						<strong class="jxr_keyword">return</strong> CommandResult.newOKCommandResult();
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  					}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  					<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  						<strong class="jxr_keyword">return</strong> CommandResult.newCancelledCommandResult();
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  					}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  				}
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  			});
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (element instanceof InstanceSpecification) {
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 			<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_comment">			 * ConnectorSelectionDialog elementSelector =</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_comment">			 * new ConnectorSelectionDialog (shell, model, (InstanceSpecification) element);</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_comment">			 * elementSelector.setTitle("Select connector");</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_comment">			 * elementSelector.setMessage("Select an implementation for connector " + selectedConnector.getName ());</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_comment">			 * elementSelector.open();</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_comment">			 * if (elementSelector.getReturnCode () == IDialogConstants.OK_ID) {</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> <em class="jxr_comment">			 * final Object[] result = elementSelector.getResult ();</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> <em class="jxr_comment">			 * if ((result.length == 2) &amp;&amp; (result[0] instanceof Class) &amp;&amp; (result[1] instanceof Class)) {</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_comment">			 * CommandSupport.exec ("Select connector", new Runnable () {</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_comment">			 * public void run () {</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> <em class="jxr_comment">			 * Object newConnType = StereotypeUtil.getApplication ((Class) result[0], ConnectorType.class);</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> <em class="jxr_comment">			 * Object newConnImpl = StereotypeUtil.getApplication ((Class) result[1], ConnectorImpl.class);</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> <em class="jxr_comment">			 * }</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_comment">			 * });</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_comment">			 * }</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_comment">			 * }</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_comment">			 */</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		}
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 	}
<a class="jxr_linenumber" name="L121" href="#L121">121</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
